﻿using BlockMania.GeneralStates.Screen_03_Settings;
using BlockMania.Util;

namespace BlockMania.GeneralStates.Screen_02_Play
{
	internal static class BlockSpeed
	{
		private const int START_DELAY = 2000;
		internal static readonly Delay DELAY = new Delay(START_DELAY);

		internal const  int MAX_SPEED = 42;
		internal static int speed;

		internal static void Init()
		{
			Reset();
		}

		internal static void Reset()
		{
			speed = SettingStorage.speed;
			DELAY.SetTimeToPause(GetDelayTime());
		}

		internal static void Increase()
		{
			speed++;

			if (speed > MAX_SPEED)
				speed = MAX_SPEED;

			DELAY.SetTimeToPause(GetDelayTime());
		}

		internal static void Decrease()
		{
			speed--;

			if (speed < 1)
				speed = 1;

			DELAY.SetTimeToPause(GetDelayTime());
		}

		private static double GetDelayTime()
		{
			switch (speed)
			{
				case  1 : return 2000;
				case  2 : return 1900;
				case  3 : return 1800;
				case  4 : return 1700;
				case  5 : return 1600;
				case  6 : return 1500;
				case  7 : return 1400;
				case  8 : return 1300;
				case  9 : return 1200;
				case 10 : return 1100;
				case 11 : return 1000;
				case 12 : return 900;
				case 13 : return 800;
				case 14 : return 700;
				case 15 : return 600;
				case 16 : return 500;
				case 17 : return 450;
				case 18 : return 400;
				case 19 : return 350;
				case 20 : return 300;
				case 21 : return 275;
				case 22 : return 250;
				case 23 : return 225;
				case 24 : return 200;
				case 25 : return 175;
				case 26 : return 150;
				case 27 : return 140;
				case 28 : return 130;
				case 29 : return 120;
				case 30 : return 110;
				case 31 : return 100;
				case 32 : return 95;
				case 33 : return 90;
				case 34 : return 85;
				case 35 : return 80;
				case 36 : return 75;
				case 37 : return 70;
				case 38 : return 69;
				case 39 : return 68;
				case 40 : return 67;
				case 41 : return 66;
				case 42 : return 65;
				default : return START_DELAY;
			}
		}

	}
}