﻿using System.Collections.Generic;
using BlockMania.Util.BlockTools;

namespace BlockMania.GeneralStates.Screen_02_Play
{
	internal static class State_02_Row_Removal
	{
		private enum RemovalState
		{
			MARK_TILES,
			REMOVE_TILES,
			REMOVE_ROWS
		}

		private static RemovalState removalState;

		private static List<int> clearedRows = new List<int>();

		internal static void Init()
		{
			clearedRows = RowCheckTool.clearedRows; // Variabele 'RowCheckTool.clearedRows' is reeds gevuld in State_01_Regular.
			RowMarker.Start(clearedRows, RowMarker.ActionType.MARK);
			removalState = RemovalState.MARK_TILES;
		}

		internal static void HandleGameTick()
		{
			switch (removalState)
			{
				case RemovalState.MARK_TILES:
					MarkTiles();
					break;
				case RemovalState.REMOVE_TILES:
					RemoveTiles();
					break;
				case RemovalState.REMOVE_ROWS:
					RemoveRows();
					break;
			}
		}

		private static void MarkTiles()
		{
			if (RowMarker.markState == RowMarker.MarkState.IN_PROGRESS)
			{
				RowMarker.HandleGameTick();
			}
			else
			{
				RowMarker.Start(clearedRows, RowMarker.ActionType.REMOVE); // Switch the internal state of the row-marker.
				removalState = RemovalState.REMOVE_TILES;
			}
		}

		private static void RemoveTiles()
		{
			if (RowMarker.markState == RowMarker.MarkState.IN_PROGRESS)
			{
				RowMarker.HandleGameTick();
			}
			else
			{
				removalState = RemovalState.REMOVE_ROWS;
			}
		}

		private static void RemoveRows()
		{
			RowRemover.RemoveRows(clearedRows);

			removalState = RemovalState.MARK_TILES;
			Screen_2_Play.SwitchToRegularGamePlay();
		}
		
	}
}