﻿using System.Drawing;
using System.Windows.Forms;
using BlockMania.Util;

namespace BlockMania.Global
{
	internal static class GlobalCanvas
	{
		internal static Graphics canvas;

		private static Bitmap bitmap;
		private static Panel panel;

		internal static void Init(Panel p)
		{
			panel = p;
			bitmap = new Bitmap(GlobalData.PANEL_WIDTH, GlobalData.PANEL_HEIGHT);
			canvas = Graphics.FromImage(bitmap);
		}

		internal static void DrawBackgroundColor()
		{
			Tools.DrawRectangleWithBorderAndFill(
				0, 0,
				GlobalData.PANEL_WIDTH,
				GlobalData.PANEL_HEIGHT,
				GlobalData.GAME_FIELD_BORDER_WIDTH,
				GlobalColors.GAME_FIELD_BORDER_COLOR,
				GlobalColors.PANEL_BRUSH);
		}

		internal static void Render()
		{
			panel.Invoke((MethodInvoker) delegate
			{
				using (Graphics gr = panel.CreateGraphics())
				{
					gr.DrawImage(bitmap, 0, 0);
					gr.Dispose();
				}
			});
		}

	}
}