﻿namespace BlockMania.Util.BlockTools
{
	internal static class BlockTool
	{
		private static int index;

		internal static Block CeateBlock(int blockNumber)
		{
			index = blockNumber;
			return Create(blockNumber);
		}

		internal static Block CreateRandomBlock()
		{
			int randomBlockNumber = MatrixTool.GetRandomBlockNumber();
			index = randomBlockNumber;
			return CeateBlock(randomBlockNumber);
		}

		internal static Block CreateNextBlock()
		{
			index++;
			if (index >= MatrixTool.GetBlockPoolSize())
				index = 0;

			return CeateBlock(index);
		}

		private static Block Create(int blockNumber)
		{
			Block block = new Block(blockNumber);

			MatrixTool.SetMatrix(block);

			TileTool.RefreshTiles(block);
			SizeTool.SetSize(block);

			OffsetTool.CalculateInitialRowOffset(block);
			// offsetTool.CalculateInitialColOffset(block);  Doe dit pas als het block verplaatst wordt naar het field.
			TileTool.RefreshTiles(block);

			return block;
		}

	}
}