﻿using BlockMania.Global;
using BlockMania.View;

namespace BlockMania.Util.BlockTools
{
	internal static class LocationCheckTool
	{
		internal static bool ZijnAlleBlockTileLocatiesVrijOpHetGamefield(Block block)
		{
			bool areLocationsFree = true;
			foreach (Tile tile in block.tiles)
			{
				if (Gamefield.IsLocationOccupied(tile.row, tile.col))
				{
					areLocationsFree = false;
					break;
				}
			}

			return areLocationsFree;
		}

		internal static bool VallenAlleBlockTileLocatiesBinnenDeGamefieldGrens(Block block)
		{
			bool isWithinGamefield = true;
			foreach (Tile tile in block.tiles)
			{
				if (ValtLocatieBuitenDeGamefieldGrens(tile.row, tile.col))
				{
					isWithinGamefield = false;
					break;
				}
			}

			return isWithinGamefield;
		}

		private static bool ValtLocatieBuitenDeGamefieldGrens(int row, int col)
		{
			return
				col < GlobalData.COL_MIN || col > GlobalData.COL_MAX ||
				row < GlobalData.ROW_MIN || row > GlobalData.ROW_MAX;
		}

	}
}