﻿using BlockMania.Global;

namespace BlockMania.Util.BlockTools
{
	internal static class SizeTool
	{
		internal static void SetSize(Block block)
		{
			SetBlockSizeInTiles(block);
			SetPreviewBlockSizeInPixels(block);
		}

		private static void SetBlockSizeInTiles(Block block)
		{
			int rowMin = block.tiles[0].row;
			int colMin = block.tiles[0].col;

			int rowMax = 0;
			int colMax = 0;

			foreach (Tile tile in block.tiles)
			{
				if (tile.row < rowMin)
					rowMin = tile.row;

				if (tile.col < colMin)
					colMin = tile.col;

				if (tile.row > rowMax)
					rowMax = tile.row;


				if (tile.col > colMax)
					colMax = tile.col;
			}

			block.heightInTiles = (rowMax - rowMin) + 1;
			block.widthInTiles  = (colMax - colMin) + 1;
		}

		private static void SetPreviewBlockSizeInPixels(Block block)
		{
			block.heightInPixels = (block.heightInTiles * GlobalData.PREVIEW_TILE_HEIGHT);
			block.widthInPixels  = (block.widthInTiles  * GlobalData.PREVIEW_TILE_WIDTH);
		}

	}
}