using System.Drawing;
using BlockMania.Global;

namespace BlockMania.Util
{
	internal class NumberIndicator
	{
		private readonly int x;
		private readonly int y;

		private readonly Font font = FontManager.font_50;

		private readonly TextStatic label_01;
		private readonly TextStatic label_02;
		private readonly TextStatic labelShortcut;

		private readonly int width;
		private readonly int height;

		private const int SPACER = 45;

		internal NumberIndicator(string text_01, string text_02, string shortcut, int x, int y)
		{
			this.x = x;
			this.y = y;

			SizeF stringSize_01 = GlobalCanvas.canvas.MeasureString(text_01, font);
			int width_01 = (int) stringSize_01.Width;

			width = width_01 + 145;
			height = 120;

			int x1 = x + 30;
			int y1 = y + 30;

			label_01 = new TextStatic(text_01, font, GlobalColors.BRUSH_WHITE, x1, y1);
			label_02 = new TextStatic(text_02, font, GlobalColors.BRUSH_YELLOW, x1+ width_01 + 10, y1 );

			labelShortcut = new TextStatic(shortcut, font, GlobalColors.BRUSH_PINK, x + width + 20, y + height - 70);
		}

		public void SetNumber(int level)
		{
			label_02.text = level.ToString();
		}

		internal void HandleGameTick()
		{
			Draw();
		}

		private void Draw()
		{
			Tools.DrawRectangleWithBorderAndFill(x, y, width, height, 2, GlobalColors.BRUSH_PINK, GlobalColors.BRUSH_RED);

			label_01.HandleGameTick();
			label_02.HandleGameTick();
			labelShortcut.HandleGameTick();


		}


	}
}