﻿using System;

namespace BlockMania.Util.PrecisionTiming.Exception
{
	/// <summary>
	/// Occurs when a <see cref="PrecisionTimerEvent"/> is already running and the user attempts to configure something that requires stopping it first
	/// </summary>
	[Serializable]
	public class LongRunningTimerException : System.Exception
	{
		/// <summary>
		/// Occurs when a <see cref="PrecisionTimerEvent"/> is already running and the user attempts to configure something that requires stopping it first
		/// </summary>
		/// <param name="message">User friendly error message</param>
		public LongRunningTimerException(string message)
			: base(message)
		{
			Console.WriteLine(message);
		}
	}
}